require(ggplot2)
require(gam)
require(splines)

set.seed(2)
orig_data <- read.csv('spiritwt.csv')
#data$weight <- jitter(data$weight, amount=100)
orig_data <- with(orig_data, orig_data[order(temperature),])

inner <- (orig_data$temperature < 85) & (orig_data$temperature > 45) & (orig_data$dilution > 15) & (orig_data$dilution <85)
data <- orig_data[inner,]
train_size <- floor(0.15 * nrow(data)) # Use 80% of the data for training
train <- sample(seq_len(nrow(data)), size = train_size) # Generate indices for training data
test <- (-train)
outer <- which(!inner)
train_data <- data[train,]
test_data <- data[test,]
outer_data <- orig_data[outer,]

# Visualize the data
#ggplot(orig_data, aes(x = dilution, y=temperature, color=weight)) + geom_point() + scale_colour_gradientn(colours=rainbow(2))
ggplot(train_data, aes(x = dilution, y=temperature, color=weight)) + geom_point() + scale_colour_gradientn(colours=rainbow(2))
#ggplot(test_data, aes(x = dilution, y=temperature, color=weight)) + geom_point() + scale_colour_gradientn(colours=rainbow(2))
#ggplot(outer_data, aes(x = dilution, y=temperature, color=weight)) + geom_point() + scale_colour_gradientn(colours=rainbow(2))

temperature_axis <- seq(30, 100, 5)
dilution_axis <- seq(0, 100, 5)

#tbl <- reshape(data, idvar="temperature", timevar="dilution", direction="wide")[,2:16]

#fit1 <- lm(weight~dilution + temperature, data=train_data)
#fit2 <- lm(weight~poly(dilution, 2)+poly(temperature, 2), data=train_data)
#fit3 <- lm(weight~poly(dilution, 3)+poly(temperature, 3), data=train_data)
#fit4 <- lm(weight~poly(dilution, 4)+poly(temperature, 4), data=train_data)
#fit5 <- lm(weight~poly(dilution, 5)+poly(temperature, 5), data=train_data)
fit6 <- lm(weight~poly(dilution, 6)+poly(temperature, 6), data=train_data)
summary(fit6)

# Visualize the regressor
prediction <- predict(fit_poly_best, orig_data)
filled.contour(matrix(prediction, nrow=21, ncol=15), nlevels=255)

# Task 1:
# In the summary of the polynomial regression with degreess 6,
# we can see the fields t-value and p-value [Pr(>|t|)].
# The null hypothesis of the statistic is that the true value
# of the coefficient is 0. 
# Use this information to determine to determine what are
# degrees of the polynomial best explains the data with
# confidence 99%.
# Write code that proves (on it's output) that the degrees are really the best.

# Task 2:
# If we we would like to use natural spline, resp. smoothing spline
# instead of polynomial, what would number of degrees of freedom would be required
# for each predictor variable, again best explaining the data
# with confidence 99%? Write code that proves the answer.
#
# Note: Instead of summary(), which is not applicable here,
# you need to use the anova() statistic.
#
# For smoothing spline, assume that degrees of freedom is a natural number.
# Use the functions `gam` and `s` instead of `lm` resp. `ns`.

fit_ns6 <- lm(weight~ns(dilution, 6)+ns(temperature, 6), data=train_data)
fit_s6 <- gam(weight~s(dilution, 6)+s(temperature, 6), data=train_data)
summary(fit_natural_spline)

# Task 3:
# Compute Residual Sum of Squares (RSS) for each of the found models on testing data and outer data.
# compare which model performs the best according to this criterion.
# Discuss the interpolating and extrapolating capabilities of the models.
# Note: On testing data, this evaluates the interpolating capabilities, wheter on the outer 
# data, this evaluates the extrapolating capabilities of the learned model.

# TODO: Your code here

# Task 4:
# Plot each of those models on `orig_data`. Discuss.
#
# Then, for each of the methods (polynomial, natural spline, smoothing spline)
# also learn and plot a model with:
#  * 5 degrees of freedom for both regressor variables for polynomial.
#  * 6 degrees of freedom for both regressor variables for natural spline.
#  * 6 degrees of freedom for both regressor variables for smoothing spline.
# (Note: That is signifianctly more than optimal.)
# Do you visually see a difference compared to the models with best numbers of DoF?
# Discuss the interpolating (test_data)
# and extrapolating (outer_data) capabilities.
